Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfosm.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfosm.F90	(revision 13727)
@@ -103,6 +103,8 @@
    INTEGER :: idebug = 236
    INTEGER :: jdebug = 228
+   
    !! * Substitutions
 #  include "do_loop_substitute.h90"
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -298,5 +300,5 @@
      zz0 =       rn_abs       ! surface equi-partition in 2-bands
      zz1 =  1. - rn_abs
-     DO_2D_00_00
+     DO_2D( 0, 0, 0, 0 )
         ! Surface downward irradiance (so always +ve)
         zrad0(ji,jj) = qsr(ji,jj) * r1_rho0_rcp
@@ -308,5 +310,5 @@
      END_2D
      ! Turbulent surface fluxes and fluxes averaged over depth of the OSBL
-     DO_2D_00_00
+     DO_2D( 0, 0, 0, 0 )
         zthermal = rab_n(ji,jj,1,jp_tem)
         zbeta    = rab_n(ji,jj,1,jp_sal)
@@ -335,5 +337,5 @@
      ! Assume constant La#=0.3
      CASE(0)
-        DO_2D_00_00
+        DO_2D( 0, 0, 0, 0 )
            zus_x = zcos_wind(ji,jj) * zustar(ji,jj) / 0.3**2
            zus_y = zsin_wind(ji,jj) * zustar(ji,jj) / 0.3**2
@@ -343,5 +345,5 @@
      ! Assume Pierson-Moskovitz wind-wave spectrum
      CASE(1)
-        DO_2D_00_00
+        DO_2D( 0, 0, 0, 0 )
            ! Use wind speed wndm included in sbc_oce module
            zustke(ji,jj) = MAX ( 0.016 * wndm(ji,jj), 1.0e-8 )
@@ -351,5 +353,5 @@
      CASE(2)
         zfac =  2.0_wp * rpi / 16.0_wp
-        DO_2D_00_00
+        DO_2D( 0, 0, 0, 0 )
            ! The Langmur number from the ECMWF model appears to give La<0.3 for wind-driven seas.
            !    The coefficient 0.8 gives La=0.3  in this situation.
@@ -364,5 +366,5 @@
      ! Langmuir velocity scale (zwstrl), La # (zla)
      ! mixed scale (zvstr), convective velocity scale (zwstrc)
-     DO_2D_00_00
+     DO_2D( 0, 0, 0, 0 )
         ! Langmuir velocity scale (zwstrl), at T-point
         zwstrl(ji,jj) = ( zustar(ji,jj) * zustar(ji,jj) * zustke(ji,jj) )**pthird
@@ -400,5 +402,5 @@
       hbl(:,:) = MAX(hbl(:,:), gdepw(:,:,3,Kmm) )
       ibld(:,:) = 3
-      DO_3D_00_00( 4, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 4, jpkm1 )
          IF ( hbl(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) THEN
             ibld(ji,jj) = MIN(mbkt(ji,jj), jk)
@@ -406,5 +408,5 @@
       END_3D
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
             zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
             zbeta    = rab_n(ji,jj,1,jp_sal)
@@ -476,5 +478,5 @@
       zdhdt(:,:) = MIN(zdhdt(:,:), (zhbl_t(:,:) - hbl(:,:))/rn_Dt + ww(ji,jj,ibld(ji,jj))) ! adjustment to represent limiting by ocean bottom
 
-      DO_3D_00_00( 4, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 4, jpkm1 )
          IF ( zhbl_t(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) THEN
             ibld(ji,jj) =  MIN(mbkt(ji,jj), jk)
@@ -485,5 +487,5 @@
 ! Step through model levels taking account of buoyancy change to determine the effect on dhdt
 !
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          IF ( ibld(ji,jj) - imld(ji,jj) > 1 ) THEN
 !
@@ -503,5 +505,6 @@
                        & - zbeta * ( zs_bl(ji,jj) - ts(ji,jj,jm,jp_sal,Kmm) ) ), 0.0 ) + zvel_max
 
-                  zhbl_s = zhbl_s + MIN( - zwb_ent(ji,jj) / zdb * rn_Dt / FLOAT(ibld(ji,jj)-imld(ji,jj) ), e3w(ji,jj,jk,Kmm) )
+                  zhbl_s = zhbl_s + MIN( - zwb_ent(ji,jj) / zdb * rn_Dt / FLOAT(ibld(ji,jj)-imld(ji,jj) ),   &
+                     &                     e3w(ji,jj,jk,Kmm) )
                   zhbl_s = MIN(zhbl_s, ht(ji,jj))
 
@@ -549,5 +552,5 @@
      ! Consider later  combining this into the loop above and looking for columns
      ! where the index for base of the boundary layer have changed
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
             zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
             zbeta    = rab_n(ji,jj,1,jp_sal)
@@ -594,5 +597,6 @@
                      zwb_ent(ji,jj) = 0._wp
                   ENDIF
-                  inhml = MAX( INT( zari * zhbl(ji,jj) / e3t(ji,jj,ibld(ji,jj),Kmm) ) , 1 )
+                  inhml = MAX( INT( zari * zhbl(ji,jj)   &
+                     &              / e3t(ji,jj,ibld(ji,jj),Kmm) ), 1 )
                   imld(ji,jj) = MAX( ibld(ji,jj) - inhml, 1)
                   zhml(ji,jj) = gdepw(ji,jj,imld(ji,jj),Kmm)
@@ -610,5 +614,6 @@
                      zari = MIN( 4.5 * ( zvstr(ji,jj)**2 ) &
                        & / ( zdb_bl(ji,jj) * zhbl(ji,jj) ) + 0.01  , 0.2 )
-                     inhml = MAX( INT( zari * zhbl(ji,jj) / e3t(ji,jj,ibld(ji,jj),Kmm) ) , 1 )
+                     inhml = MAX( INT( zari * zhbl(ji,jj)   &
+                        &             / e3t(ji,jj,ibld(ji,jj),Kmm) ), 1 )
                      imld(ji,jj) = MAX( ibld(ji,jj) - inhml, 1)
                      zhml(ji,jj) = gdepw(ji,jj,imld(ji,jj),Kmm)
@@ -630,5 +635,5 @@
       ! Average over the depth of the mixed layer in the convective boundary layer
       ! Also calculate entrainment fluxes for temperature and salinity
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
          zbeta    = rab_n(ji,jj,1,jp_sal)
@@ -700,5 +705,5 @@
     !
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ztemp = zu_ml(ji,jj)
          zu_ml(ji,jj) = zu_ml(ji,jj) * zcos_wind(ji,jj) + zv_ml(ji,jj) * zsin_wind(ji,jj)
@@ -718,5 +723,5 @@
      zuw_bse = 0._wp
      zvw_bse = 0._wp
-     DO_2D_00_00
+     DO_2D( 0, 0, 0, 0 )
 
         IF ( lconv(ji,jj) ) THEN
@@ -735,5 +740,5 @@
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
        !
           IF ( lconv (ji,jj) ) THEN
@@ -783,5 +788,5 @@
        END_2D
 !
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
        !
           IF ( lconv (ji,jj) ) THEN
@@ -827,5 +832,5 @@
       !     zvisml_sc = zwstrl * zhbl * EXP ( -( zhol / 0.183_wp )**2 )
       !  ENDWHERE
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
             zdifml_sc(ji,jj) = zhml(ji,jj) * ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird
@@ -841,5 +846,5 @@
        END_2D
 !
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
              DO jk = 2, imld(ji,jj)   ! mixed layer diffusivity
@@ -891,5 +896,5 @@
 
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
          IF ( lconv(ji,jj) ) THEN
            DO jk = 2, imld(ji,jj)
@@ -924,5 +929,5 @@
        ENDWHERE
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
              DO jk = 2, imld(ji,jj)
@@ -956,5 +961,5 @@
        ENDWHERE
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF (lconv(ji,jj) ) THEN
              DO jk = 2, imld(ji,jj)
@@ -988,5 +993,5 @@
        ENDWHERE
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
              DO jk = 2 , imld(ji,jj)
@@ -1016,5 +1021,5 @@
        ENDWHERE
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
          IF ( lconv(ji,jj) ) THEN
             DO jk = 2, imld(ji,jj)
@@ -1053,5 +1058,5 @@
        ENDWHERE
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
             DO jk = 2, imld(ji,jj)
@@ -1088,5 +1093,5 @@
 ! Make surface forced velocity non-gradient terms go to zero at the base of the mixed layer.
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          IF ( lconv(ji,jj) ) THEN
             DO jk = 2, ibld(ji,jj)
@@ -1117,5 +1122,5 @@
        ! Temporary fix to avoid instabilities when zdb_bl becomes very very small
        zsc_uw_1 = 0._wp ! 50.0 * zla**(8.0/3.0) * zustar**2 * zhbl / ( zdb_bl + epsln )
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           DO jk= 2, ibld(ji,jj)
              znd = gdepw(ji,jj,jk,Kmm) / zhbl(ji,jj)
@@ -1130,5 +1135,5 @@
 ! Entrainment contribution.
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           IF ( lconv(ji,jj) ) THEN
             DO jk = 1, imld(ji,jj) - 1
@@ -1165,5 +1170,5 @@
        ! rotate non-gradient velocity terms back to model reference frame
 
-       DO_2D_00_00
+       DO_2D( 0, 0, 0, 0 )
           DO jk = 2, ibld(ji,jj)
              ztemp = ghamu(ji,jj,jk)
@@ -1179,5 +1184,5 @@
 ! KPP-style Ri# mixing
        IF( ln_kpprimix) THEN
-          DO_3D_10_10( 2, jpkm1 )
+          DO_3D( 1, 0, 1, 0, 2, jpkm1 )      !* Shear production at uw- and vw-points (energy conserving form)
              z3du(ji,jj,jk) = 0.5 * (  uu(ji,jj,jk-1,Kmm) -  uu(ji  ,jj,jk,Kmm) )   &
                   &                 * (  uu(ji,jj,jk-1,Kbb) -  uu(ji  ,jj,jk,Kbb) ) * wumask(ji,jj,jk) &
@@ -1188,5 +1193,5 @@
           END_3D
       !
-         DO_3D_00_00( 2, jpkm1 )
+         DO_3D( 0, 0, 0, 0, 2, jpkm1 )
             !                                          ! shear prod. at w-point weightened by mask
             zesh2  =  ( z3du(ji-1,jj,jk) + z3du(ji,jj,jk) ) / MAX( 1._wp , umask(ji-1,jj,jk) + umask(ji,jj,jk) )   &
@@ -1199,5 +1204,5 @@
          END_3D
 
-          DO_2D_00_00
+          DO_2D( 0, 0, 0, 0 )
              DO jk = ibld(ji,jj) + 1, jpkm1
                 zdiffut(ji,jj,jk) = zrimix(ji,jj,jk)*rn_difri
@@ -1210,5 +1215,5 @@
 ! KPP-style set diffusivity large if unstable below BL
        IF( ln_convmix) THEN
-          DO_2D_00_00
+          DO_2D( 0, 0, 0, 0 )
              DO jk = ibld(ji,jj) + 1, jpkm1
                IF(  MIN( rn2(ji,jj,jk), rn2b(ji,jj,jk) ) <= -1.e-12 ) zdiffut(ji,jj,jk) = rn_difconv
@@ -1218,16 +1223,16 @@
 
        ! Lateral boundary conditions on zvicos (sign unchanged), needed to caclulate viscosities on u and v grids
-       CALL lbc_lnk( 'zdfosm', zviscos(:,:,:), 'W', 1. )
+       CALL lbc_lnk( 'zdfosm', zviscos(:,:,:), 'W', 1.0_wp )
 
        ! GN 25/8: need to change tmask --> wmask
 
-     DO_3D_00_00( 2, jpkm1 )
+     DO_3D( 0, 0, 0, 0, 2, jpkm1 )
           p_avt(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), avtb(jk) ) * tmask(ji,jj,jk)
           p_avm(ji,jj,jk) = MAX( zviscos(ji,jj,jk), avmb(jk) ) * tmask(ji,jj,jk)
      END_3D
       ! Lateral boundary conditions on ghamu and ghamv, currently on W-grid  (sign unchanged), needed to caclulate gham[uv] on u and v grids
-     CALL lbc_lnk_multi( 'zdfosm', p_avt, 'W', 1. , p_avm, 'W', 1.,   &
-      &                  ghamu, 'W', 1. , ghamv, 'W', 1. )
-       DO_3D_00_00( 2, jpkm1 )
+     CALL lbc_lnk_multi( 'zdfosm', p_avt, 'W', 1.0_wp , p_avm, 'W', 1.0_wp,   &
+      &                  ghamu, 'W', 1.0_wp , ghamv, 'W', 1.0_wp )
+       DO_3D( 0, 0, 0, 0, 2, jpkm1 )
             ghamu(ji,jj,jk) = ( ghamu(ji,jj,jk) + ghamu(ji+1,jj,jk) ) &
                &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji + 1,jj,jk) ) * umask(ji,jj,jk)
@@ -1241,6 +1246,6 @@
         ! Lateral boundary conditions on final outputs for gham[ts],  on W-grid  (sign unchanged)
         ! Lateral boundary conditions on final outputs for gham[uv],  on [UV]-grid  (sign unchanged)
-        CALL lbc_lnk_multi( 'zdfosm', ghamt, 'W', 1. , ghams, 'W', 1.,   &
-         &                  ghamu, 'U', 1. , ghamv, 'V', 1. )
+        CALL lbc_lnk_multi( 'zdfosm', ghamt, 'W', 1.0_wp , ghams, 'W', 1.0_wp,   &
+         &                  ghamu, 'U', 1.0_wp , ghamv, 'V', 1.0_wp )
 
        IF(ln_dia_osm) THEN
@@ -1282,5 +1287,5 @@
       END IF
       ! Lateral boundary conditions on p_avt  (sign unchanged)
-      CALL lbc_lnk( 'zdfosm', p_avt(:,:,:), 'W', 1. )
+      CALL lbc_lnk( 'zdfosm', p_avt(:,:,:), 'W', 1.0_wp )
       !
    END SUBROUTINE zdf_osm
@@ -1343,4 +1348,12 @@
      ENDIF
 
+
+     !                              ! Check wave coupling settings !
+     !                         ! Further work needed - see ticket #2447 !
+     IF( nn_osm_wave == 2 ) THEN
+        IF (.NOT. ( ln_wave .AND. ln_sdw )) &
+           & CALL ctl_stop( 'zdf_osm_init : ln_zdfosm and nn_osm_wave=2, ln_wave and ln_sdw must be true' )
+     END IF
+
      !                              ! allocate zdfosm arrays
      IF( zdf_osm_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_osm_init : unable to allocate arrays' )
@@ -1382,5 +1395,5 @@
         etmean(:,:,:) = 0.e0
 
-        DO_3D_00_00( 1, jpkm1 )
+        DO_3D( 0, 0, 0, 0, 1, jpkm1 )
            etmean(ji,jj,jk) = tmask(ji,jj,jk)                     &
                 &  / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
@@ -1396,5 +1409,5 @@
         etmean(:,:,:) = 0.e0
 
-        DO_3D_00_00( 1, jpkm1 )
+        DO_3D( 0, 0, 0, 0, 1, jpkm1 )
            etmean(ji,jj,jk) = tmask(ji, jj,jk)                           &
                 & / MAX( 1., 2.* tmask(ji,jj,jk)                           &
@@ -1457,5 +1470,5 @@
         id1 = iom_varid( numror, 'wn'   , ldstop = .FALSE. )
         IF( id1 > 0 ) THEN                       ! 'wn' exists; read
-           CALL iom_get( numror, jpdom_autoglo, 'wn', ww, ldxios = lroxios )
+           CALL iom_get( numror, jpdom_auto, 'wn', ww, ldxios = lroxios )
            WRITE(numout,*) ' ===>>>> :  ww read from restart file'
         ELSE
@@ -1466,6 +1479,6 @@
         id2 = iom_varid( numror, 'hbli'   , ldstop = .FALSE. )
         IF( id1 > 0 .AND. id2 > 0) THEN                       ! 'hbl' exists; read and return
-           CALL iom_get( numror, jpdom_autoglo, 'hbl' , hbl , ldxios = lroxios )
-           CALL iom_get( numror, jpdom_autoglo, 'hbli', hbli, ldxios = lroxios  )
+           CALL iom_get( numror, jpdom_auto, 'hbl' , hbl , ldxios = lroxios )
+           CALL iom_get( numror, jpdom_auto, 'hbli', hbli, ldxios = lroxios  )
            WRITE(numout,*) ' ===>>>> :  hbl & hbli read from restart file'
            IF( lroxios ) CALL iom_swap( TRIM(cxios_context) )
@@ -1501,5 +1514,5 @@
      !
      hbl(:,:)  = 0._wp              ! here hbl used as a dummy variable, integrating vertically N^2
-     DO_3D_11_11( 1, jpkm1 )
+     DO_3D( 1, 1, 1, 1, 1, jpkm1 )  ! Mixed layer level: w-level
         ikt = mbkt(ji,jj)
         hbl(ji,jj) = hbl(ji,jj) + MAX( rn2(ji,jj,jk) , 0._wp ) * e3w(ji,jj,jk,Kmm)
@@ -1507,5 +1520,5 @@
      END_3D
      !
-     DO_2D_11_11
+     DO_2D( 1, 1, 1, 1 )
         iiki = imld_rst(ji,jj)
         hbl (ji,jj) = gdepw(ji,jj,iiki  ,Kmm) * ssmask(ji,jj)    ! Turbocline depth
@@ -1546,5 +1559,5 @@
 
       ! add non-local temperature and salinity flux
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          pts(ji,jj,jk,jp_tem,Krhs) =  pts(ji,jj,jk,jp_tem,Krhs)                      &
             &                 - (  ghamt(ji,jj,jk  )  &
@@ -1614,5 +1627,5 @@
       !code saving tracer trends removed, replace with trdmxl_oce
 
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )       ! add non-local u and v fluxes
          puu(ji,jj,jk,Krhs) =  puu(ji,jj,jk,Krhs)                      &
             &                 - (  ghamu(ji,jj,jk  )  &
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfphy.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfphy.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfphy.F90	(revision 13727)
@@ -28,4 +28,5 @@
    USE sbc_oce        ! surface module (only for nn_isf in the option compatibility test)
    USE sbcrnf         ! surface boundary condition: runoff variables
+   USE sbc_ice        ! sea ice drag
 #if defined key_agrif
    USE agrif_oce_interp   ! interpavm
@@ -253,4 +254,14 @@
       ENDIF
       !
+#if defined key_si3
+      IF ( ln_drgice_imp) THEN
+         IF ( ln_isfcav ) THEN
+            rCdU_top(:,:) = rCdU_top(:,:) + ssmask(:,:) * tmask(:,:,1) * rCdU_ice(:,:)
+         ELSE
+            rCdU_top(:,:) = rCdU_ice(:,:)
+         ENDIF
+      ENDIF
+#endif
+      ! 
       !                       !==  Kz from chosen turbulent closure  ==!   (avm_k, avt_k)
       !
@@ -302,13 +313,13 @@
       !                                         !* Lateral boundary conditions (sign unchanged)
       IF( l_zdfsh2 ) THEN
-         CALL lbc_lnk_multi( 'zdfphy', avm_k, 'W', 1. , avt_k, 'W', 1.,   &
-            &                avm  , 'W', 1. , avt  , 'W', 1. , avs , 'W', 1. )
+         CALL lbc_lnk_multi( 'zdfphy', avm_k, 'W', 1.0_wp , avt_k, 'W', 1.0_wp,   &
+            &                avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
       ELSE
-         CALL lbc_lnk_multi( 'zdfphy', avm  , 'W', 1. , avt  , 'W', 1. , avs , 'W', 1. )
+         CALL lbc_lnk_multi( 'zdfphy', avm  , 'W', 1.0_wp , avt  , 'W', 1.0_wp , avs , 'W', 1.0_wp )
       ENDIF
       !
       IF( l_zdfdrg ) THEN     ! drag  have been updated (non-linear cases)
-         IF( ln_isfcav ) THEN   ;  CALL lbc_lnk_multi( 'zdfphy', rCdU_top, 'T', 1. , rCdU_bot, 'T', 1. )   ! top & bot drag
-         ELSE                   ;  CALL lbc_lnk      ( 'zdfphy', rCdU_bot, 'T', 1. )                       ! bottom drag only
+         IF( ln_isfcav ) THEN   ;  CALL lbc_lnk_multi( 'zdfphy', rCdU_top, 'T', 1.0_wp , rCdU_bot, 'T', 1.0_wp )   ! top & bot drag
+         ELSE                   ;  CALL lbc_lnk      ( 'zdfphy', rCdU_bot, 'T', 1.0_wp )                       ! bottom drag only
          ENDIF
       ENDIF
@@ -326,4 +337,6 @@
       !
    END SUBROUTINE zdf_phy
+
+
    INTEGER FUNCTION zdf_phy_alloc()
       !!----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfric.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfric.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfric.F90	(revision 13727)
@@ -156,5 +156,5 @@
       !
       !                       !==  avm and avt = F(Richardson number)  ==!
-      DO_3D_10_10( 2, jpkm1 )
+      DO_3D( 1, 0, 1, 0, 2, jpkm1 )       ! coefficient = F(richardson number) (avm-weighted Ri)
          zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , avm(ji,jj,jk) * rn2(ji,jj,jk) / ( p_sh2(ji,jj,jk) + 1.e-20 ) )  )
          zav   = rn_avmri * zcfRi**nn_ric
@@ -169,10 +169,10 @@
       IF( ln_mldw ) THEN      !==  set a minimum value in the Ekman layer  ==!
          !
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )             !* Ekman depth
             zustar = SQRT( taum(ji,jj) * r1_rho0 )
             zhek   = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )   ! Ekman depth
             zh_ekm(ji,jj) = MAX(  rn_mldmin , MIN( zhek , rn_mldmax )  )   ! set allowed range
          END_2D
-         DO_3D_00_00( 2, jpkm1 )
+         DO_3D( 0, 0, 0, 0, 2, jpkm1 )   !* minimum mixing coeff. within the Ekman layer
             IF( gdept(ji,jj,jk,Kmm) < zh_ekm(ji,jj) ) THEN
                p_avm(ji,jj,jk) = MAX(  p_avm(ji,jj,jk), rn_wvmix  ) * wmask(ji,jj,jk)
@@ -211,6 +211,6 @@
             !
             IF( MIN( id1, id2 ) > 0 ) THEN         ! restart exists => read it
-               CALL iom_get( numror, jpdom_autoglo, 'avt_k', avt_k, ldxios = lroxios )
-               CALL iom_get( numror, jpdom_autoglo, 'avm_k', avm_k, ldxios = lroxios )
+               CALL iom_get( numror, jpdom_auto, 'avt_k', avt_k, ldxios = lroxios )
+               CALL iom_get( numror, jpdom_auto, 'avm_k', avm_k, ldxios = lroxios )
             ENDIF
             IF( lroxios ) CALL iom_swap( TRIM(cxios_context) )
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfsh2.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfsh2.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfsh2.F90	(revision 13727)
@@ -24,4 +24,5 @@
    !! * Substitutions
 #  include "do_loop_substitute.h90"
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -59,13 +60,17 @@
       !
       DO jk = 2, jpkm1
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )     !* 2 x shear production at uw- and vw-points (energy conserving form)
             zsh2u(ji,jj) = ( p_avm(ji+1,jj,jk) + p_avm(ji,jj,jk) ) &
                &         * (   uu(ji,jj,jk-1,Kmm) -   uu(ji,jj,jk,Kmm) ) &
-               &         * (   uu(ji,jj,jk-1,Kbb) -   uu(ji,jj,jk,Kbb) ) / ( e3uw(ji,jj,jk,Kmm) * e3uw(ji,jj,jk,Kbb) ) * wumask(ji,jj,jk)
+               &         * (   uu(ji,jj,jk-1,Kbb) -   uu(ji,jj,jk,Kbb) ) & 
+               &         / ( e3uw(ji,jj,jk  ,Kmm) * e3uw(ji,jj,jk,Kbb) ) &
+               &         * wumask(ji,jj,jk)
             zsh2v(ji,jj) = ( p_avm(ji,jj+1,jk) + p_avm(ji,jj,jk) ) &
                &         * (   vv(ji,jj,jk-1,Kmm) -   vv(ji,jj,jk,Kmm) ) &
-               &         * (   vv(ji,jj,jk-1,Kbb) -   vv(ji,jj,jk,Kbb) ) / ( e3vw(ji,jj,jk,Kmm) * e3vw(ji,jj,jk,Kbb) ) * wvmask(ji,jj,jk)
+               &         * (   vv(ji,jj,jk-1,Kbb) -   vv(ji,jj,jk,Kbb) ) &
+               &         / ( e3vw(ji,jj,jk  ,Kmm) * e3vw(ji,jj,jk,Kbb) ) &
+               &         * wvmask(ji,jj,jk)
          END_2D
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )     !* shear production at w-point ! coast mask: =2 at the coast ; =1 otherwise (NB: wmask useless as zsh2 are masked)
             p_sh2(ji,jj,jk) = 0.25 * (   ( zsh2u(ji-1,jj) + zsh2u(ji,jj) ) * ( 2. - umask(ji-1,jj,jk) * umask(ji,jj,jk) )   &
                &                       + ( zsh2v(ji,jj-1) + zsh2v(ji,jj) ) * ( 2. - vmask(ji,jj-1,jk) * vmask(ji,jj,jk) )   )
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfswm.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfswm.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/ZDF/zdfswm.F90	(revision 13727)
@@ -63,5 +63,5 @@
       !
       zcoef = 1._wp * 0.353553_wp
-      DO_3D_00_00( 2, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 2, jpkm1 )
          zqb = zcoef * hsw(ji,jj) * tsd2d(ji,jj) * EXP( -3. * wnum(ji,jj) * gdepw(ji,jj,jk,Kmm) ) * wmask(ji,jj,jk)
          !
